fork 0k-charms
You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

262 lines
6.6 KiB

  1. #!/bin/bash
  2. set -eux
  3. ## 0k git remote path
  4. GIT_0K_BASE=${GIT_0K_BASE:-"0k-ro:/var/git"}
  5. ## 0k git remote options
  6. GIT_0K_CLONE_OPTIONS=${GIT_0K_CLONE_OPTIONS:-""}
  7. ##
  8. ## Install 0k-manage
  9. ##
  10. mkdir -p /opt/apps
  11. (
  12. if [ -d "/opt/apps/0k-manage" ]; then
  13. cd /opt/apps/0k-manage &&
  14. git pull -r
  15. else
  16. cd /opt/apps &&
  17. git clone $GIT_0K_CLONE_OPTIONS "$GIT_0K_BASE/0k/0k-manage.git" &&
  18. cd /opt/apps/0k-manage &&
  19. git checkout 0k/prod/master
  20. fi
  21. pip install sact.epoch || exit 1
  22. if [ "$(python -c 'import sact.epoch' 2>&1 | tail -n 1)" == "ImportError: No module named interface" ]; then
  23. echo "Error: conflicting installation of zope.interface detected. Trying workaround."
  24. (
  25. cd /usr/local/lib/python2.7/dist-packages
  26. mv zope zope-bad
  27. ) &&
  28. pip install zope.interface --upgrade &&
  29. pip install zope.component --upgrade
  30. if [ "$(python -c 'import sact.epoch' 2>&1 | tail -n 1)" == "" ]; then
  31. echo "Workaround worked."
  32. else
  33. echo "Failed work around."
  34. exit 1
  35. fi
  36. fi
  37. # ln -sf /opt/apps/0k-manage/src/bin/* /usr/local/bin/
  38. )
  39. ##
  40. ## Remove possible previous docker-compose related stuff
  41. ##
  42. if [ -f /etc/compose/local.conf ]; then
  43. sed -ri 's%^(. /opt/venv/docker-compose/bin/activate)$%# \1 ## docker-compsoe not needed anymore%g' \
  44. /etc/compose/local.conf
  45. fi
  46. ##
  47. ## Install 0k-charm
  48. ##
  49. (
  50. apt-get install -y kal-shlib-charm kal-shlib-cache kal-shlib-cmdline </dev/null
  51. if [ -d "/opt/apps/0k-charm" ]; then
  52. cd /opt/apps/0k-charm &&
  53. git checkout master &&
  54. git pull -r
  55. else
  56. cd /opt/apps &&
  57. git clone $GIT_0K_CLONE_OPTIONS "$GIT_0K_BASE/0k/0k-charm.git"
  58. fi
  59. ln -sfn /opt/apps/0k-charm/bin/charm /usr/local/sbin/charm
  60. )
  61. ##
  62. ## Install 0k-charms
  63. ##
  64. (
  65. if [ -d "/opt/apps/0k-charms" ]; then
  66. cd /opt/apps/0k-charms &&
  67. git checkout master &&
  68. git pull -r
  69. else
  70. cd /opt/apps &&
  71. git clone $GIT_0K_CLONE_OPTIONS "$GIT_0K_BASE/0k/0k-charms.git"
  72. fi
  73. if ! [ -d "/srv/charm-store" ]; then
  74. mkdir -p /srv/charm-store
  75. fi
  76. ln -sfn /opt/apps/0k-charms /srv/charm-store/0k-charms
  77. )
  78. ##
  79. ## Install lxc-scripts
  80. ##
  81. (
  82. if ! [ -d "/opt/apps/lxc-scripts" ]; then
  83. cd /opt/apps &&
  84. git clone $GIT_0K_CLONE_OPTIONS "$GIT_0K_BASE/0k/lxc-scripts.git"
  85. fi
  86. cd /opt/apps/lxc-scripts &&
  87. git checkout master &&
  88. git pull -r &&
  89. ln -sfn /opt/apps/lxc-scripts/bin/lxc-* /usr/local/sbin/ &&
  90. if [ -f /etc/default/lxc ]; then
  91. if [ -f /etc/default/lxc.pre-install ]; then
  92. cp /etc/default/lxc.pre-install /etc/default/lxc
  93. else
  94. cp /etc/default/lxc /etc/default/lxc.pre-install
  95. fi
  96. [ -d /usr/lib/lxc/templates ] && {
  97. ln -sfn /opt/apps/lxc-scripts/usr/lib/lxc/templates/lxc-0k-ubuntu-cloud /usr/lib/lxc/templates/
  98. echo TEMPLATE_PATH=/usr/lib/lxc/templates >> /etc/default/lxc
  99. }
  100. [ -d /usr/share/lxc/templates ] && {
  101. ln -sfn /opt/apps/lxc-scripts/usr/lib/lxc/templates/lxc-0k-ubuntu-cloud /usr/share/lxc/templates
  102. echo TEMPLATE_PATH=/usr/share/lxc/templates >> /etc/default/lxc
  103. }
  104. fi
  105. )
  106. ##
  107. ## Install 0k-docker
  108. ##
  109. (
  110. if [ -d "/opt/apps/0k-docker" ]; then
  111. cd /opt/apps/0k-docker &&
  112. git checkout master &&
  113. git pull -r
  114. else
  115. cd /opt/apps &&
  116. git clone $GIT_0K_CLONE_OPTIONS "$GIT_0K_BASE/0k/0k-docker"
  117. fi
  118. ln -sfn /opt/apps/0k-docker/src/bin/* /usr/local/sbin/
  119. ln -sfn /opt/apps/0k-docker/src/bin/docker-clean /etc/cron.daily/docker-clean
  120. ## in update, will remove broken links to binaries that were removed
  121. find -L /usr/local/sbin -maxdepth 1 -type l -ilname /opt/apps/0k-docker/\* -delete
  122. )
  123. ##
  124. ## Install 0k.io certificate authority
  125. ##
  126. ## Note that docker should be installed after (or be restarted).
  127. apt-get install -y curl </dev/null
  128. ## This does not seem to work anymore (docker v1.12, ubutnu 14.04 on gani)
  129. ca=/etc/ssl/ca.0k.io.pem
  130. need_restart=
  131. oldmd5=
  132. if [ -f "$ca" ]; then
  133. oldmd5=$(md5sum "$ca")
  134. fi
  135. echo "Fetching 0k.io CA certificate..."
  136. curl http://docker.0k.io/get/ca.0k.io.pem > "$ca"
  137. if [[ "$(md5sum "$ca")" != "$oldmd5" ]]; then
  138. need_restart=1
  139. cat "$ca" >> /etc/ssl/certs/ca-certificates.crt
  140. fi
  141. ## This is the new way: https://docs.docker.com/engine/security/certificates/
  142. ca_ln="/etc/docker/certs.d/docker.0k.io/ca.crt"
  143. mkdir -p "$(dirname "$ca_ln")"
  144. if ! [ -L "$ca_ln" ] || [ "$(realpath "$ca_ln")" != "$ca" ] ; then
  145. ln -sfn "$ca" "$ca_ln"
  146. need_restart=1
  147. fi
  148. if [ "$need_restart" ]; then
  149. service docker restart
  150. fi
  151. echo "Login into our server."
  152. docker login -u vm -p iamavm https://docker.0k.io
  153. sed -ri 's/^#(net\.ipv4\.ip_forward=1)$/\1/g' /etc/sysctl.conf
  154. sysctl -w net.ipv4.ip_forward=1
  155. ##
  156. ## Installation of compose
  157. ##
  158. docker pull docker.0k.io/compose
  159. if [ -d "/opt/apps/0k-compose" ]; then
  160. cd "/opt/apps/0k-compose" &&
  161. git pull -r
  162. else
  163. mkdir -p /opt/apps && cd /opt/apps
  164. git clone "$GIT_0K_BASE"/0k/0k-compose.git
  165. fi
  166. [ -e /usr/local/bin/compose ] || ln -sfnv /opt/apps/0k-compose/bin/compose /usr/local/bin/
  167. rm -rf /var/cache/compose
  168. cat <<EOF > /etc/default/datastore
  169. DATASTORE=/srv/datastore
  170. SNAPSHOT_BACKUP=/var/backups/snapshot
  171. EOF
  172. cat <<EOF > /etc/default/compose
  173. ## if not provided, this will be the default service launched.
  174. export DEFAULT_SERVICES=""
  175. ## In new compose (running in docker) this is not yet really supported,
  176. ## and is it wanted ?
  177. #export DEFAULT_PROJECT_NAME=$(hostname | cut -f 2 -d . )
  178. #DEFAULT_PROJECT_NAME=\${DEFAULT_PROJECT_NAME,,} ## to lowercase
  179. export DOCKER_DATASTORE=\$([ -e /etc/default/datastore ] && . /etc/default/datastore && echo \$DATASTORE)
  180. export DATASTORE=\$DOCKER_DATASTORE/data
  181. export CONFIGSTORE=\$DOCKER_DATASTORE/config
  182. EOF
  183. if ! egrep "^DEFAULT_COMPOSE_FILE=/etc/compose/compose.yml$" /etc/compose/local.conf >/dev/null 2>&1; then
  184. mkdir /etc/compose -p
  185. touch /etc/compose/local.conf
  186. echo "DEFAULT_COMPOSE_FILE=/etc/compose/compose.yml" >> /etc/compose/local.conf
  187. fi
  188. ##
  189. ## Install pgm
  190. ##
  191. (
  192. if [ -d "/opt/apps/0k-pgm" ]; then
  193. cd /opt/apps/0k-pgm &&
  194. git pull -r
  195. else
  196. cd /opt/apps &&
  197. git clone $GIT_0K_CLONE_OPTIONS "$GIT_0K_BASE/0k/0k-pgm.git" &&
  198. cd /opt/apps/0k-pgm &&
  199. git checkout master
  200. fi
  201. ln -sfnv /opt/apps/0k-pgm/bin/* /usr/local/bin/
  202. find -L /usr/local/bin -maxdepth 1 -type l -ilname /opt/apps/0k-pgm/bin/\* -delete
  203. apt-get install -y --force-yes pv buffer < /dev/null
  204. apt-get install -y postgresql-client </dev/null
  205. )